library easy_log;

import './easy_log_manager.dart';
import './easy_log_debug.dart';
import './easy_log_umeng.dart';
import './easy_log_fb.dart';

const String kEasyLogParamErrorCode     = "kEasyLogParamErrorCode";
const String kEasyLogParamErrorType     = "kEasyLogParamErrorType";
const String kEasyLogParamErrorDomain   = "kEasyLogParamErrorDomain";
const String kEasyLogParamErrorMessage  = "kEasyLogParamErrorMessage";
const String kEasyLogParamResult        = "kEasyLogParamResult";

enum EasyLogChannel {
  Debug,
  Umeng,
  Facebook,
}

class EasyLog {
  static void addLogChanel(EasyLogChannel channel) {
    switch (channel) {
      case EasyLogChannel.Debug:
        EasyLogManager().addLogChanel(EasyLogDebug());
        break;
      case EasyLogChannel.Umeng:
      EasyLogManager().addLogChanel(EasyLogUmeng());
        break;
      case EasyLogChannel.Facebook:
      EasyLogManager().addLogChanel(EasyLogFacebook());
        break;
      default:
    }
  }

  static void logEvent(String eventName) {
    EasyLogManager().event(eventName);
  }

  static void logEventWithParams(
      String eventName, Map<String, String> params) {
    EasyLogManager().event(eventName, attributes: params);
  }

  static void logEventWithParamAndValue(
    String eventName,
    String name,
    String value, {
    String name1,
    String value1,
    String name2,
    String value2,
    String name3,
    String value3,
    String name4,
    String value4,
    String name5,
    String value5,
  }) {
    Map<String, String> params = {};
    if(name is String && value is String) {
      params[name] = value;
    }
    if(name1 is String && value1 is String) {
      params[name1] = value1;
    }
    if(name2 is String && value2 is String) {
      params[name2] = value2;
    }
    if(name3 is String && value3 is String) {
      params[name3] = value3;
    }
    if(name4 is String && value4 is String) {
      params[name4] = value4;
    }
    if(name5 is String && value5 is String) {
      params[name5] = value5;
    }
    EasyLogManager().event(eventName, attributes: params);
  }

  static void calcEvent(String eventName, int number) {
    EasyLogManager().event(eventName, attributes: {}, number: number);
  }

  static void calcEventWithParams(
      String eventName, int number, Map<String, String> params) {
    EasyLogManager().event(eventName, attributes: params, number: number);
  }

  static void calcEventWithParamAndValue(
    String eventName,
    int number,
    String name,
    String value, {
    String name1,
    String value1,
    String name2,
    String value2,
    String name3,
    String value3,
    String name4,
    String value4,
    String name5,
    String value5,
  }) {
    Map<String, String> params = {};
    if(name is String && value is String) {
      params[name] = value;
    }
    if(name1 is String && value1 is String) {
      params[name1] = value1;
    }
    if(name2 is String && value2 is String) {
      params[name2] = value2;
    }
    if(name3 is String && value3 is String) {
      params[name3] = value3;
    }
    if(name4 is String && value4 is String) {
      params[name4] = value4;
    }
    if(name5 is String && value5 is String) {
      params[name5] = value5;
    }
    EasyLogManager().event(eventName, attributes: params, number: number);
  }

  static void beginPageView(String pageName) {
    EasyLogManager().beginLogPageView(pageName);
  }

  static void endPageView(String pageName) {
    EasyLogManager().endLogPageView(pageName);
  }
}
