import 'dart:core';

import './easy_log_base.dart';

class EasyLogManager {
  factory EasyLogManager() => _sharedInstance();
  static EasyLogManager _instance;
  EasyLogManager._();
  static EasyLogManager _sharedInstance() {
    if (_instance == null) {
    _instance = EasyLogManager._();
    }
    return _instance;
  }

  List<EasyLogBase> _channelList = [];

  void addLogChanel(EasyLogBase channel) {
    if(!_channelList.contains(channel)) {
      _channelList.add(channel);
    }
  }

  void event(String eventId, {
    Map<String, String> attributes,
    int number
  }) {
    _channelList.forEach((EasyLogBase channel) {
      if(number is int) {
        channel.eventWithAttributesAndCounter(eventId, attributes, number);
      } else {
        if(attributes is Map) {
          channel.eventWithAttributes(eventId, attributes);
        } else {
          channel.event(eventId);
        }
      }
    });
  }

  void beginLogPageView(String pageName) {
    _channelList.forEach((EasyLogBase channel) {
      channel.beginLogPageView(pageName);
    });
  }

  void endLogPageView(String pageName) {
    _channelList.forEach((EasyLogBase channel) {
      channel.endLogPageView(pageName);
    });
  }
}
