import './easy_log_base.dart';
import 'package:flutter_umeng_analytics_gf/flutter_umeng_analytics_gf.dart';

class EasyLogUmeng implements EasyLogBase {

  factory EasyLogUmeng() => _sharedInstance();
  static EasyLogUmeng _instance;
  EasyLogUmeng._();
  static EasyLogUmeng _sharedInstance() {
    if (_instance == null) {
    _instance = EasyLogUmeng._();
    }
    return _instance;
  }

  void event(String eventId) {
    UMengAnalytics.logEvent(eventId);
  }

  void eventWithLabel(String eventId, String label) {
    UMengAnalytics.logEvent(eventId, label: label);
  }

  void eventWithAttributes(String eventId, Map<String, String> attributes) {
    UMengAnalytics.logEventWithAttributes(eventId, attributes);
  }

  void eventWithAttributesAndCounter(String eventId, Map<String, String> attributes, int number) {
    UMengAnalytics.logEventWithAttributesAndCounter(eventId, attributes, number);
  }

  void beginLogPageView(String pageName) {
    UMengAnalytics.beginPageView(pageName);
  }

  void endLogPageView(String pageName) {
    UMengAnalytics.endPageView(pageName);
  }
}